package com;
import java.io.*;
import java.net.*;
import java.util.*;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

public class CallApi {

	String apiUrl = "";
	boolean isError = false;
	String ErrorCode = "";
	String ErrorMsg = "";
	String response="";
	public String getResponse()
	{
		return response;
	}
	
	public CallApi() {
	}
	public CallApi(String ServiceURL) {
		apiUrl = ServiceURL;	
	}

	public RChilliBulkUpload ParseResumeBinary(String fileData, String fileName, String userKey, String version, String subUserId) {
		String input = "{"
							+ "\"filedata\":\"" + fileData + "\","
							+ "\"filename\":\"" + fileName + "\","
							+ "\"userkey\":\"" + userKey+ "\","
							+ "\"version\":\"" + version+ "\","
							+ "\"subuserid\":\"" + subUserId+ "\""
					+ "}";
		response = CallService(input);
		RChilliBulkUpload resumeParserData = processOutput(response);
		return resumeParserData;
	}
	
	
	

	public String CallService(String input) {
		StringBuilder sbOutput = new StringBuilder();
		try {

			URL url = new URL(apiUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setDoOutput(true);
			conn.setRequestMethod("POST");
			conn.setRequestProperty("Content-Type", "application/json");
			OutputStream os = conn.getOutputStream();
			os.write(input.getBytes());
			os.flush();
			BufferedReader br = null;
			if (conn.getResponseCode() != 200) 
			{

				br = new BufferedReader(new InputStreamReader(conn.getErrorStream()));
			} else 
			{
				br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			}
			String output;
			while ((output = br.readLine()) != null) {
				sbOutput.append(output);
			}
			conn.disconnect();
		} catch (MalformedURLException e) {
			e.printStackTrace();
			isError = true;
			ErrorCode = "500";
			ErrorMsg = e.getLocalizedMessage();
		} catch (IOException e) {
			isError = true;
			ErrorCode = "500";
			ErrorMsg = e.getLocalizedMessage();
			e.printStackTrace();
		}

		return sbOutput.toString();
	}

	public RChilliBulkUpload processOutput(String jsonResponse) {
		RChilliBulkUpload bulkUpload = new RChilliBulkUpload();
		JSONParser parser = new JSONParser();
		Object outputObject = null;
		try {
			outputObject = parser.parse(jsonResponse.toString());
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			isError = true;
			ErrorCode = "500";
			ErrorMsg = e.getLocalizedMessage();
			Error error= new Error();
			error.setHasError(isError);
			error.setErrorCode(ErrorCode);
			error.setErrorMsg(ErrorMsg);
			bulkUpload.setError(error);
			return bulkUpload;
		}
		JSONObject root = (JSONObject) outputObject;
		if (jsonResponse.contains("\"error\":")) {
			JSONObject obj = (JSONObject) root.get("error");
			isError = true;
			ErrorMsg = (String) obj.get("errormsg");
			ErrorCode = Long.toString((long) obj.get("errorcode"));
			Error error= new Error();
			error.setHasError(isError);
			error.setErrorCode(ErrorCode);
			error.setErrorMsg(ErrorMsg);
			bulkUpload.setError(error);
			return bulkUpload;
		}

		Error error= new Error();
		error.setHasError(false);
		error.setErrorCode("");
		error.setErrorMsg("");
		bulkUpload.setError(error);
		JSONObject resumeBulkData = (JSONObject) root.get("RChilliBulkUpload");
		bulkUpload.setBase64Data(resumeBulkData.get("Base64Data").toString());
	    bulkUpload.setFileName(resumeBulkData.get("FileName").toString());
	    bulkUpload.setSubUserId(resumeBulkData.get("SubUserId").toString());
		JSONObject obj = (JSONObject) resumeBulkData.get("ResumeParserData");
		JSONObject jsonObj = (JSONObject) obj;
		String value = "";
		ResumeParserData resumeParserData= new ResumeParserData();
		

		SegregatedQualification segregatedQualification;
		List<SegregatedQualification> listSegregatedQualification = new ArrayList<SegregatedQualification>();
		SegregatedExperience segregatedExperience;
		List<SegregatedExperience> listSegregatedExperience = new ArrayList<SegregatedExperience>();
		SegregatedSkill segregatedSkill;
		List<SegregatedSkill> listSegregatedSkill = new ArrayList<SegregatedSkill>();
		SegregatedCertification segregatedCertification;
		List<SegregatedCertification> listSegregatedCertification = new ArrayList<SegregatedCertification>();
		SegregatedAchievement segregatedAchievement;
		List<SegregatedAchievement> listSegregatedAchievement = new ArrayList<SegregatedAchievement>();
		SegregatedPublication segregatedPublication;
		List<SegregatedPublication> listSegregatedPublication = new ArrayList<SegregatedPublication>();
		Location location;
		CountryCode countryCode;
		for (Object key : jsonObj.keySet()) {
			// based on you key types
			String nodeName = (String) key;
			Object val = jsonObj.get(nodeName);
			try {
				/*
				 * if(val instanceof String) { System.out.print("String-"); } if(val instanceof
				 * JSONObject) { System.out.print("Object-"); } if(val instanceof JSONArray) {
				 * System.out.print("Array-"); } System.out.println(nodeName+" : "+val);
				 */

				if (val instanceof String) {

					value = (String) val;
					if (nodeName.equalsIgnoreCase("ResumeFileName")) {
						resumeParserData.setResumeFileName(value);
					} else if (nodeName.equalsIgnoreCase("ParsingDate")) {
						resumeParserData.setParsingDate(value);
					} else if (nodeName.equalsIgnoreCase("DateOfBirth")) {
						resumeParserData.setDateOfBirth(value);
					} else if (nodeName.equalsIgnoreCase("Gender")) {
						resumeParserData.setGender(value);
					} else if (nodeName.equalsIgnoreCase("FatherName")) {
						resumeParserData.setFatherName(value);
					} else if (nodeName.equalsIgnoreCase("MotherName")) {
						resumeParserData.setMotherName(value);
					} else if (nodeName.equalsIgnoreCase("MaritalStatus")) {
						resumeParserData.setMaritalStatus(value);
					} else if (nodeName.equalsIgnoreCase("Nationality")) {
						resumeParserData.setNationality(value);
					} else if (nodeName.equalsIgnoreCase("UniqueID")) {
						resumeParserData.setUniqueID(value);
					} else if (nodeName.equalsIgnoreCase("LicenseNo")) {
						resumeParserData.setLicenseNo(value);
					} else if (nodeName.equalsIgnoreCase("PanNo")) {
						resumeParserData.setPanNo(value);
					} else if (nodeName.equalsIgnoreCase("VisaStatus")) {
						resumeParserData.setVisaStatus(value);
					} else if (nodeName.equalsIgnoreCase("Category")) {
						resumeParserData.setCategory(value);
					} else if (nodeName.equalsIgnoreCase("SubCategory")) {
						resumeParserData.setSubCategory(value);
					} else if (nodeName.equalsIgnoreCase("Qualification")) {
						resumeParserData.setQualification(value);
					} else if (nodeName.equalsIgnoreCase("Certification")) {
						resumeParserData.setCertification(value);
					} else if (nodeName.equalsIgnoreCase("SkillBlock")) {
						resumeParserData.setSkillBlock(value);
					} else if (nodeName.equalsIgnoreCase("SkillKeywords")) {
						resumeParserData.setSkillKeywords(value);
					} else if (nodeName.equalsIgnoreCase("Experience")) {
						resumeParserData.setExperience(value);
					} else if (nodeName.equalsIgnoreCase("CurrentEmployer")) {
						resumeParserData.setCurrentEmployer(value);
					} else if (nodeName.equalsIgnoreCase("JobProfile")) {
						resumeParserData.setJobProfile(value);
					} else if (nodeName.equalsIgnoreCase("GapPeriod")) {
						resumeParserData.setGapPeriod(value);
					} else if (nodeName.equalsIgnoreCase("AverageStay")) {
						resumeParserData.setAverageStay(value);
					} else if (nodeName.equalsIgnoreCase("LongestStay")) {
						resumeParserData.setLongestStay(value);
					} else if (nodeName.equalsIgnoreCase("Summary")) {
						resumeParserData.setSummary(value);
					} else if (nodeName.equalsIgnoreCase("ExecutiveSummary")) {
						resumeParserData.setExecutiveSummary(value);
					} else if (nodeName.equalsIgnoreCase("ManagementSummary")) {
						resumeParserData.setManagementSummary(value);
					} else if (nodeName.equalsIgnoreCase("Coverletter")) {
						resumeParserData.setCoverletter(value);
					} else if (nodeName.equalsIgnoreCase("Publication")) {
						resumeParserData.setPublication(value);
					} else if (nodeName.equalsIgnoreCase("Availability")) {
						resumeParserData.setAvailability(value);
					} else if (nodeName.equalsIgnoreCase("Hobbies")) {
						resumeParserData.setHobbies(value);
					} else if (nodeName.equalsIgnoreCase("Objectives")) {
						resumeParserData.setObjectives(value);
					} else if (nodeName.equalsIgnoreCase("Achievements")) {
						resumeParserData.setAchievements(value);
					} else if (nodeName.equalsIgnoreCase("References")) {
						resumeParserData.setReferences(value);
					} else if (nodeName.equalsIgnoreCase("CustomFields")) {
						resumeParserData.setCustomFields(value);
					} else if (nodeName.equalsIgnoreCase("DetailResume")) {
						resumeParserData.setDetailResume(value);
					} else if (nodeName.equalsIgnoreCase("HtmlResume")) {
						resumeParserData.setHtmlResume(value);
					}

				} else if (nodeName.equalsIgnoreCase("SegregatedQualification")) {
					try {
						
						JSONArray eduDrill = (JSONArray) val;
						Iterator i = eduDrill.iterator();
						Institution institute;

						while (i.hasNext()) {
							segregatedQualification = new SegregatedQualification();
							institute = new Institution();
							location = new Location();
							JSONObject edu = (JSONObject) i.next();
							JSONObject instituion = (JSONObject) edu.get("Institution");
							institute.setName((String) instituion.get("Name"));
							institute.setType((String) instituion.get("Type"));

							JSONObject loc = (JSONObject) instituion.get("Location");

							location.setCity((String) loc.get("City"));
							location.setState((String) loc.get("State"));
							location.setStateIsoCode((String) loc.get("StateIsoCode"));
							location.setCountry((String) loc.get("Country"));

							JSONObject cCode = (JSONObject) loc.get("CountryCode");
							countryCode = new CountryCode();
							countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
							countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
							countryCode.setUNCode((String) cCode.get("UNCode"));
							location.setCountryCode(countryCode);

							institute.setLocation(location);
							JSONObject subInstituion = (JSONObject) edu.get("SubInstitution");
							segregatedQualification.setInstitution(institute);
							try {
								if (subInstituion != null) {
									SubInstitution subInstitute = new SubInstitution();
									subInstitute.setName((String) subInstituion.get("Name"));
									subInstitute.setType((String) subInstituion.get("Type"));

									loc = (JSONObject) subInstituion.get("Location");

									location.setCity((String) loc.get("City"));
									location.setState((String) loc.get("State"));
									location.setStateIsoCode((String) loc.get("StateIsoCode"));
									location.setCountry((String) loc.get("Country"));

									cCode = (JSONObject) loc.get("CountryCode");
									countryCode = new CountryCode();
									countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
									countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
									countryCode.setUNCode((String) cCode.get("UNCode"));
									location.setCountryCode(countryCode);
									subInstitute.setLocation(location);
									segregatedQualification.setSubInstitution(subInstitute);
								}
							} catch (Exception ex) {

							}
							
							segregatedQualification.setFormattedDegreePeriod((String) edu.get("FormattedDegreePeriod"));
							segregatedQualification.setStartDate((String) edu.get("StartDate"));
							segregatedQualification.setEndDate((String) edu.get("EndDate"));

							JSONObject degree = (JSONObject) edu.get("Degree");
							Degree deg = new Degree();
							deg.setDegreeName((String) degree.get("DegreeName"));
							deg.setNormalizeDegree((String) degree.get("NormalizeDegree"));
							List<String> specialization=(ArrayList<String>) degree.get("Specialization");
							deg.setSpecialization(specialization);
							segregatedQualification.setDegree(deg);
							JSONObject degreeAggregate = (JSONObject) edu.get("Aggregate");
							if (degreeAggregate != null) {
								Aggregate aggregate = new Aggregate();
								aggregate.setValue((String) degreeAggregate.get("Value"));
								aggregate.setMeasureType((String) degreeAggregate.get("MeasureType"));
								segregatedQualification.setAggregate(aggregate);
							}

							listSegregatedQualification.add(segregatedQualification);
						}
						resumeParserData.setSegregatedQualification(listSegregatedQualification);
					} catch (Exception ex) {
						System.out.println(ex);
					}

				} else if (nodeName.equalsIgnoreCase("SegregatedSkill")) {
					try {

						JSONArray skillSet = (JSONArray) val;
						Iterator i = skillSet.iterator();
						while (i.hasNext()) {
							segregatedSkill = new SegregatedSkill();
							JSONObject skills1 = (JSONObject) i.next();
							segregatedSkill.setSkill((String) skills1.get("Skill"));
							segregatedSkill.setType((String) skills1.get("Type"));
							segregatedSkill.setFormattedName((String) skills1.get("FormattedName"));
							segregatedSkill.setAlias((String) skills1.get("Alias"));
							segregatedSkill.setEvidence((String) skills1.get("Evidence"));
							segregatedSkill.setLastUsed((String) skills1.get("LastUsed"));
							
							segregatedSkill.setOntology((String) skills1.get("Ontology"));
							//segregatedSkill.setExperienceInMonths(Integer.parseInt((String) skills1.get("ExperienceInMonths")));
							listSegregatedSkill.add(segregatedSkill);
						}
						resumeParserData.setSegregatedSkill(listSegregatedSkill);
					} catch (Exception ex) {
						System.out.println(ex.getMessage());
					}
				} else if (nodeName.equalsIgnoreCase("SegregatedExperience")) {
					try {
					
						JSONArray expDrill = (JSONArray)val;
						Iterator i = expDrill.iterator();
						int expId = 1;
						while (i.hasNext()) {
							segregatedExperience = new SegregatedExperience();
							JSONObject exp = (JSONObject) i.next();
							Employer employer = new Employer();
							JSONObject emp = (JSONObject) exp.get("Employer");
							employer.setEmployerName((String) emp.get("EmployerName"));
							employer.setFormattedName((String) emp.get("FormattedName"));
							segregatedExperience.setEmployer(employer);
							JobProfile job = new JobProfile();
							JSONObject jobProfile = (JSONObject) exp.get("JobProfile");
							job.setTitle((String) jobProfile.get("Title"));
							job.setFormattedName((String) jobProfile.get("FormattedName"));
							job.setAlias((String) jobProfile.get("Alias"));
							
							if(jobProfile.containsKey("RelatedSkills"))
							{
								JSONArray relatedSkills=(JSONArray) jobProfile.get("RelatedSkills");
								Iterator itr= relatedSkills.iterator();
								RelatedSkills reSkill;
								List<RelatedSkills> relatedSkillList= new ArrayList();
								while(itr.hasNext())
								{
									JSONObject relatedSkill=(JSONObject )itr.next();
									reSkill= new RelatedSkills();
									reSkill.setSkill((String)relatedSkill.get("Skill"));
									reSkill.setProficiencyLevel((String)relatedSkill.get("ProficiencyLevel"));
									relatedSkillList.add(reSkill);
								}
								job.setRelatedSkills(relatedSkillList);
							}
							
							//job.setRelatedSkills((String) jobProfile.get("RelatedSkills"));

							segregatedExperience.setJobProfile(job);
							location = new Location();
							JSONObject loc = (JSONObject) exp.get("Location");

							location.setCity((String) loc.get("City"));
							location.setState((String) loc.get("State"));
							location.setStateIsoCode((String) loc.get("StateIsoCode"));
							location.setCountry((String) loc.get("Country"));

							JSONObject cCode = (JSONObject) loc.get("CountryCode");
							countryCode = new CountryCode();
							countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
							countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
							countryCode.setUNCode((String) cCode.get("UNCode"));

							location.setCountryCode(countryCode);
							segregatedExperience.setLocation(location);
							segregatedExperience.setJobPeriod((String) exp.get("JobPeriod"));
							segregatedExperience.setFormattedJobPeriod((String) exp.get("FormattedJobPeriod"));
							segregatedExperience.setStartDate((String) exp.get("StartDate"));
							segregatedExperience.setEndDate((String) exp.get("EndDate"));
							segregatedExperience.setJobDescription((String) exp.get("JobDescription"));
							JSONArray projDrill = (JSONArray) exp.get("Projects");
							Iterator proj = projDrill.iterator();
							List<Projects> listProjects = new ArrayList<Projects>();
							while (proj.hasNext()) {
								Projects projects = new Projects();
								JSONObject project = (JSONObject) proj.next();
								projects.setProjectName((String) project.get("ProjectName"));
								projects.setUsedSkills((String) project.get("UsedSkills"));
								projects.setTeamSize((String) project.get("TeamSize"));
								listProjects.add(projects);
							}
							segregatedExperience.setProjects(listProjects);
							listSegregatedExperience.add(segregatedExperience);
						}
						resumeParserData.setSegregatedExperience(listSegregatedExperience);
					} catch (Exception ex) {
						System.out.println(ex.getMessage());
					}
				} else if (nodeName.equalsIgnoreCase("ResumeLanguage")) {
					try {
						JSONObject resumeLang = (JSONObject) val;
						ResumeLanguage resumeLanguage = new ResumeLanguage();

						resumeLanguage.setLanguage((String) resumeLang.get("Language"));
						resumeLanguage.setLanguageCode((String) resumeLang.get("LanguageCode"));
						resumeParserData.setResumeLanguage(resumeLanguage);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("ResumeCountry")) {
					try {
						JSONObject rCountry = (JSONObject) val;
						ResumeCountry resumeCountry = new ResumeCountry();

						resumeCountry.setCountry((String) rCountry.get("Country"));
						resumeCountry.setEvidence((String) rCountry.get("Evidence"));

						JSONObject cCode = (JSONObject) rCountry.get("CountryCode");
						countryCode = new CountryCode();
						countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
						countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
						countryCode.setUNCode((String) cCode.get("UNCode"));
						resumeCountry.setCountryCode(countryCode);

						resumeParserData.setResumeCountry(resumeCountry);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("Name")) {
					try {
						JSONObject candidateName = (JSONObject) val;
						Name name = new Name();

						name.setFullName((String) candidateName.get("FullName"));
						name.setTitleName((String) candidateName.get("TitleName"));
						name.setFirstName((String) candidateName.get("FirstName"));
						name.setMiddleName((String) candidateName.get("MiddleName"));
						name.setLastName((String) candidateName.get("LastName"));
						name.setFormattedName((String) candidateName.get("FormattedName"));

						resumeParserData.setName(name);
					} catch (Exception ex) {
					}
				}

				else if (nodeName.equalsIgnoreCase("PassportDetail")) {
					try {
						JSONObject passport = (JSONObject) val;
						PassportDetail passportDetail = new PassportDetail();

						passportDetail.setPassportNumber((String) passport.get("PassportNumber"));
						passportDetail.setDateOfExpiry((String) passport.get("DateOfExpiry"));
						passportDetail.setDateOfIssue((String) passport.get("DateOfIssue"));
						passportDetail.setPlaceOfIssue((String) passport.get("PlaceOfIssue"));
						resumeParserData.setPassportDetail(passportDetail);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("CurrentSalary")) {
					try {
						JSONObject currentSalary = (JSONObject) val;
						CurrentSalary currSalary = new CurrentSalary();

						currSalary.setAmount((String) currentSalary.get("Amount"));
						currSalary.setSymbol((String) currentSalary.get("Symbol"));
						currSalary.setCurrency((String) currentSalary.get("Currency"));
						currSalary.setUnit((String) currentSalary.get("Unit"));
						currSalary.setText((String) currentSalary.get("Text"));
						resumeParserData.setCurrentSalary(currSalary);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("ExpectedSalary")) {
					try {
						JSONObject expectedSalary = (JSONObject) val;
						ExpectedSalary expSalary = new ExpectedSalary();

						expSalary.setAmount((String) expectedSalary.get("Amount"));
						expSalary.setSymbol((String) expectedSalary.get("Symbol"));
						expSalary.setCurrency((String) expectedSalary.get("Currency"));
						expSalary.setUnit((String) expectedSalary.get("Unit"));
						expSalary.setText((String) expectedSalary.get("Text"));
						resumeParserData.setExpectedSalary(expSalary);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("WorkedPeriod")) {
					try {
						JSONObject WorkedPeriod = (JSONObject) val;
						WorkedPeriod workPeriod = new WorkedPeriod();
						workPeriod.setTotalExperienceInMonths((String) WorkedPeriod.get("TotalExperienceInMonths"));
						workPeriod.setTotalExperienceInYear((String) WorkedPeriod.get("TotalExperienceInYear"));
						workPeriod.setTotalExperienceRange((String) WorkedPeriod.get("TotalExperienceRange"));
						resumeParserData.setWorkedPeriod(workPeriod);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("TemplateOutput")) {
					try {
						TemplateOutput template = new TemplateOutput();
						JSONObject TemplateOutput = (JSONObject) val;
						template.setTemplateOutputFileName((String) TemplateOutput.get("TemplateOutputFileName"));
						template.setTemplateOutputData((String) TemplateOutput.get("TemplateOutputData"));
						resumeParserData.setTemplateOutput(template);

					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("CandidateImage")) {
					try {
						JSONObject CandidateImage = (JSONObject) val;
						CandidateImage candidateImage = new CandidateImage();

						candidateImage.setCandidateImageFormat((String) CandidateImage.get("CandidateImageFormat"));
						candidateImage.setCandidateImageData((String) CandidateImage.get("CandidateImageData"));
						resumeParserData.setCandidateImage(candidateImage);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("LanguageKnown")) {
					try {
						JSONArray skillSet = (JSONArray) val;
						Iterator i = skillSet.iterator();
						List<LanguageKnown> languageKnown = new ArrayList<LanguageKnown>();
						while (i.hasNext()) {
							LanguageKnown language = new LanguageKnown();
							JSONObject lang = (JSONObject) i.next();
							language.setLanguage((String) lang.get("Language"));
							language.setLanguageCode((String) lang.get("LanguageCode"));
							languageKnown.add(language);
						}
						resumeParserData.setLanguageKnown(languageKnown);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("Email")) {
					try {
						JSONArray emails = (JSONArray) val;
						Iterator i = emails.iterator();
						List<Email> listEmail = new ArrayList<Email>();
						while (i.hasNext()) {
							Email eml = new Email();
							JSONObject email = (JSONObject) i.next();
							eml.setEmailAddress((String) email.get("EmailAddress"));
							listEmail.add(eml);
						}
						resumeParserData.setEmail(listEmail);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("PhoneNumber")) {
					try {
						JSONArray phoneNumber = (JSONArray) val;
						Iterator i = phoneNumber.iterator();
						List<PhoneNumber> listPhoneNumber = new ArrayList<PhoneNumber>();
						while (i.hasNext()) {
							PhoneNumber phNumber = new PhoneNumber();
							JSONObject phone = (JSONObject) i.next();
							phNumber.setNumber((String) phone.get("Number"));
							phNumber.setISDCode((String) phone.get("ISDCode"));
							phNumber.setOriginalNumber((String) phone.get("OriginalNumber"));
							phNumber.setFormattedNumber((String) phone.get("FormattedNumber"));
							phNumber.setType((String) phone.get("Type"));
							listPhoneNumber.add(phNumber);
						}
						resumeParserData.setPhoneNumber(listPhoneNumber);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("WebSite")) {
					try {
						JSONArray webSites = (JSONArray) val;
						Iterator i = webSites.iterator();
						List<WebSite> listWebSite = new ArrayList<WebSite>();
						while (i.hasNext()) {
							WebSite webSite = new WebSite();
							JSONObject web = (JSONObject) i.next();
							webSite.setUrl((String) web.get("Url"));
							webSite.setType((String) web.get("Type"));
							listWebSite.add(webSite);
						}
						resumeParserData.setWebSite(listWebSite);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("Address")) {
					try {
						JSONArray address = (JSONArray) val;
						Iterator i = address.iterator();
						List<Address> listAddress = new ArrayList<Address>();
						while (i.hasNext()) {
							Address addr = new Address();
							JSONObject adrss = (JSONObject) i.next();
							addr.setStreet((String) adrss.get("Street"));
							addr.setCity((String) adrss.get("City"));
							addr.setState((String) adrss.get("State"));
							addr.setStateIsoCode((String) adrss.get("StateIsoCode"));
							addr.setCountry((String) adrss.get("Country"));
							addr.setZipCode((String) adrss.get("ZipCode"));
							addr.setFormattedAddress((String) adrss.get("FormattedAddress"));
							addr.setType((String) adrss.get("Type"));

							JSONObject cCode = (JSONObject) adrss.get("CountryCode");
							countryCode = new CountryCode();
							countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
							countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
							countryCode.setUNCode((String) cCode.get("UNCode"));
							addr.setCountryCode(countryCode);

							listAddress.add(addr);
						}
						resumeParserData.setAddress(listAddress);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("CurrentLocation")) {
					try {
						JSONArray currentLocation = (JSONArray) val;
						Iterator i = currentLocation.iterator();
						List<CurrentLocation> listCurrentLocation = new ArrayList<CurrentLocation>();
						while (i.hasNext()) {
							CurrentLocation curLocation = new CurrentLocation();
							JSONObject currentLoc = (JSONObject) i.next();
							curLocation.setCity((String) currentLoc.get("City"));
							curLocation.setState((String) currentLoc.get("State"));
							curLocation.setStateIsoCode((String) currentLoc.get("StateIsoCode"));
							curLocation.setCountry((String) currentLoc.get("Country"));

							JSONObject cCode = (JSONObject) currentLoc.get("CountryCode");
							countryCode = new CountryCode();
							countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
							countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
							countryCode.setUNCode((String) cCode.get("UNCode"));
							curLocation.setCountryCode(countryCode);

							listCurrentLocation.add(curLocation);
						}
						resumeParserData.setCurrentLocation(listCurrentLocation);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("PreferredLocation")) {
					try {
						JSONArray preferredLocation = (JSONArray) val;
						Iterator i = preferredLocation.iterator();
						List<PreferredLocation> listPreferredLocation = new ArrayList<PreferredLocation>();
						while (i.hasNext()) {
							PreferredLocation perLocation = new PreferredLocation();
							JSONObject preferredLoc = (JSONObject) i.next();
							perLocation.setCity((String) preferredLoc.get("City"));
							perLocation.setState((String) preferredLoc.get("State"));
							perLocation.setStateIsoCode((String) preferredLoc.get("StateIsoCode"));
							perLocation.setCountry((String) preferredLoc.get("Country"));

							JSONObject cCode = (JSONObject) preferredLoc.get("CountryCode");
							countryCode = new CountryCode();
							countryCode.setIsoAlpha2((String) cCode.get("IsoAlpha2"));
							countryCode.setIsoAlpha3((String) cCode.get("IsoAlpha3"));
							countryCode.setUNCode((String) cCode.get("UNCode"));
							perLocation.setCountryCode(countryCode);

							listPreferredLocation.add(perLocation);
						}
						resumeParserData.setPreferredLocation(listPreferredLocation);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("SegregatedCertification")) {
					try {
						JSONArray preferredLocation = (JSONArray) val;
						Iterator i = preferredLocation.iterator();

						while (i.hasNext()) {
							segregatedCertification = new SegregatedCertification();
							JSONObject segCertification = (JSONObject) i.next();
							segregatedCertification
									.setCertificationTitle((String) segCertification.get("CertificationTitle"));
							segregatedCertification.setAuthority((String) segCertification.get("Authority"));
							segregatedCertification
									.setCertificationCode((String) segCertification.get("CertificationCode"));
							segregatedCertification.setIsExpiry((String) segCertification.get("IsExpiry"));
							segregatedCertification.setStartDate((String) segCertification.get("StartDate"));
							segregatedCertification.setEndDate((String) segCertification.get("EndDate"));
							segregatedCertification
									.setCertificationUrl((String) segCertification.get("CertificationUrl"));

							listSegregatedCertification.add(segregatedCertification);
						}
						resumeParserData.setSegregatedCertification(listSegregatedCertification);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("SegregatedPublication")) {
					try {
						JSONArray segPub = (JSONArray) val;
						Iterator i = segPub.iterator();

						while (i.hasNext()) {
							segregatedPublication = new SegregatedPublication();
							JSONObject segPublication = (JSONObject) i.next();
							segregatedPublication.setPublicationTitle((String) segPublication.get("PublicationTitle"));
							segregatedPublication.setPublisher((String) segPublication.get("Publisher"));
							segregatedPublication
									.setPublicationNumber((String) segPublication.get("PublicationNumber"));
							segregatedPublication.setPublicationUrl((String) segPublication.get("PublicationUrl"));
							segregatedPublication.setAuthors((String) segPublication.get("Authors"));
							segregatedPublication.setDescription((String) segPublication.get("Description"));
							listSegregatedPublication.add(segregatedPublication);
						}
						resumeParserData.setSegregatedPublication(listSegregatedPublication);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("SegregatedAchievement")) {
					try {
						JSONArray segAch = (JSONArray) val;
						Iterator i = segAch.iterator();

						while (i.hasNext()) {
							segregatedAchievement = new SegregatedAchievement();
							JSONObject segAchievement = (JSONObject) i.next();
							segregatedAchievement.setAwardTitle	((String) segAchievement.get("AwardTitle"));
							segregatedAchievement.setIssuer((String) segAchievement.get("Issuer"));
							segregatedAchievement.setAssociatedWith((String) segAchievement.get("AssociatedWith"));
							segregatedAchievement.setIssuingDate((String) segAchievement.get("IssuingDate"));
							
							segregatedAchievement.setDescription((String) segAchievement.get("Description"));
							listSegregatedAchievement.add(segregatedAchievement);
						}
						resumeParserData.setSegregatedAchievement(listSegregatedAchievement);
					} catch (Exception ex) {
					}
				} else if (nodeName.equalsIgnoreCase("Recommendations")) {
					try {
						JSONArray recommendations = (JSONArray) val;
						Iterator i = recommendations.iterator();
						List<Recommendations> listRecommendations = new ArrayList<Recommendations>();
						while (i.hasNext()) {
							Recommendations recommendation = new Recommendations();
							JSONObject recommend = (JSONObject) i.next();
							recommendation.setPersonName((String) recommend.get("PersonName"));
							recommendation.setCompanyName((String) recommend.get("CompanyName"));
							recommendation.setRelation((String) recommend.get("Relation"));
							recommendation.setPositionTitle((String) recommend.get("PositionTitle"));
							recommendation.setDescription((String) recommend.get("Description"));

							listRecommendations.add(recommendation);
						}
						resumeParserData.setRecommendations(listRecommendations);
					} catch (Exception ex) {
					}
				}
				else if (nodeName.equalsIgnoreCase("EmailInfo")) {
					try {
						JSONObject emailInfo = (JSONObject) val;
						EmailInfo emailInformation = new EmailInfo();

						emailInformation.setEmailTo((String) emailInfo.get("EmailTo"));
						emailInformation.setEmailFrom((String) emailInfo.get("EmailFrom"));
						emailInformation.setEmailSubject((String) emailInfo.get("EmailSubject"));
						emailInformation.setEmailBody((String) emailInfo.get("EmailBody"));
						emailInformation.setEmailCC((String) emailInfo.get("EmailCC"));
						emailInformation.setEmailReplyTo((String) emailInfo.get("EmailReplyTo"));
						resumeParserData.setEmailInfo(emailInformation);
					} catch (Exception ex) {
					}
				}

			} catch (Exception ex) {
				ex.printStackTrace();
			}
		
		}
		bulkUpload.setResumeParserData(resumeParserData);
		return bulkUpload;

	}
	public String htmlData(RChilliBulkUpload resumeInbox)
	{
		ResumeParserData resumeParserData=  resumeInbox.getResumeParserData();
		StringBuilder sbHtml = new StringBuilder();
		
		StringBuilder sbContact = new StringBuilder();
		
		
        
		sbContact.append("<table width='100%' >");
        sbContact.append("<tr><td><b>Full Name : </b></td><td>" + resumeParserData.getName().getFullName() + "</td></tr>");
        sbContact.append("<tr><td><b>Title Name : </b></td><td>" + resumeParserData.getName().getTitleName() + "</td></tr>");
        sbContact.append("<tr><td><b>First Name : </b></td><td>" +resumeParserData.getName().getFirstName() + "</td></tr>");
        sbContact.append("<tr><td><b>Middle Name : </b></td><td>" + resumeParserData.getName().getMiddleName() + "</td></tr>");
        sbContact.append("<tr><td><b>Last Name : </b></td><td>" + resumeParserData.getName().getLastName() + "</td></tr>");
        sbContact.append("<tr><td><b>Formatted Name : </b></td><td>" + resumeParserData.getName().getFormattedName() + "</td></tr>");

        List<Email> emails = resumeParserData.getEmail();
        StringBuilder sb = new StringBuilder();
        for (Email email : emails)
        {
            sb.append(email.getEmailAddress() + ",");
        }
        sbContact.append("<tr><td><b>Email : </b></td><td>" + sb.toString() + "</td></tr>");

        List<PhoneNumber> PhoneNumbers = resumeParserData.getPhoneNumber();
        sb.setLength(0);
        for(PhoneNumber phoneNumber : PhoneNumbers)
        {
            sbContact.append("<tr><td><b>" + phoneNumber.getType() + " : </b></td><td>" + phoneNumber.getFormattedNumber() +"("+phoneNumber.getISDCode()+"/"+phoneNumber.getOriginalNumber()+") </td></tr>");
        }
        List<Address> addresses = resumeParserData.getAddress();
        if (addresses.size() > 0)
        {
            for(Address address : addresses)
            {
                sbContact.append("<tr><td><b>" + address.getType() + " Address  </b></td><td></td></tr>");
                sbContact.append("<tr><td><b>Address : </b></td><td>" + address.getStreet() + "</td></tr>");
                sbContact.append("<tr><td><b>City : </b></td><td>" + address.getCity() + "</td></tr>");
                sbContact.append("<tr><td><b>State : </b></td><td>" + address.getState()+"<sub>"+address.getStateIsoCode() + "</sub></td></tr>");
                sbContact.append("<tr><td><b>Country : </b></td><td>" + address.getCountry() + "</td></tr>");
                if (!address.getCountryCode().getIsoAlpha2().isEmpty())
                {
                    sbContact.append("<tr><td><b>CountryCodes : </b></td><td>" + address.getCountryCode().getIsoAlpha2() + "/" + address.getCountryCode().getIsoAlpha3() +"/"+ address.getCountryCode().getUNCode() + "</td></tr>");
                }
                sbContact.append("<tr><td><b>Zip Code : </b></td><td>" + address.getZipCode() + "</td></tr>");                   
            }
        }
        sbContact.append("</table>");
        
        
        sbHtml.append("<h2>Contact Information</h2><hr/>");
        sbHtml.append(sbContact.toString());
        StringBuilder sbPersonal = new StringBuilder();
        sbPersonal.append("<table width=100% >");
        sbPersonal.append("<tr><td><b>Date Of Birth : </b></td><td>" + resumeParserData.getDateOfBirth() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Gender : </b></td><td>" + resumeParserData.getGender() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Nationality : </b></td><td>" + resumeParserData.getNationality() + "</td></tr>");
        sbPersonal.append("<tr><td><b>MaritalStatus : </b></td><td>" + resumeParserData.getMaritalStatus() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Father Name : </b></td><td>" + resumeParserData.getFatherName() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Mother Name : </b></td><td>" + resumeParserData.getMotherName() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Current Salary  : </b></td><td>" + resumeParserData.getCurrentSalary().getSymbol() + " " + resumeParserData.getCurrentSalary().getAmount() +"("+ resumeParserData.getCurrentSalary().getCurrency() +")/"+ resumeParserData.getCurrentSalary().getUnit() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Expected Salary : </b></td><td>" + resumeParserData.getExpectedSalary().getSymbol() + " " + resumeParserData.getExpectedSalary().getAmount() + "(" + resumeParserData.getExpectedSalary().getCurrency() + ")/" + resumeParserData.getExpectedSalary().getUnit() + "</td></tr>");
         sbPersonal.append("<tr><td><b>Passport No. : </b></td><td>" + resumeParserData.getPassportDetail().getPassportNumber() + "</td></tr>");
         sbPersonal.append("<tr><td><b>Date Of Issue : </b></td><td>" + resumeParserData.getPassportDetail().getDateOfIssue() + "</td></tr>");
         sbPersonal.append("<tr><td><b>Date Of Expiry : </b></td><td>" + resumeParserData.getPassportDetail().getDateOfExpiry() + "</td></tr>");
         sbPersonal.append("<tr><td><b>Place Of Issue : </b></td><td>" + resumeParserData.getPassportDetail().getPlaceOfIssue() + "</td></tr>");
         sbPersonal.append("<tr><td><b>Unique ID : </b></td><td>" + resumeParserData.getUniqueID() + "</td></tr>");
        sbPersonal.append("<tr><td><b>License No. : </b></td><td>" + resumeParserData.getLicenseNo() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Visa Status : </b></td><td>" + resumeParserData.getVisaStatus() + "</td></tr>");
        sbPersonal.append("<tr><td><b>Current Location : </b></td><td></td></tr>");
        List<CurrentLocation> currentLocations = resumeParserData.getCurrentLocation();
        for (CurrentLocation currentLocation : currentLocations)
        {
            sbPersonal.append("<tr><td><b>City : </b></td><td>" + currentLocation.getCity() + "</td></tr>");
            sbPersonal.append("<tr><td><b>State : </b></td><td>" + currentLocation.getState() +"<sub>"+currentLocation.getStateIsoCode() + "</sub></td></tr>");
            sbPersonal.append("<tr><td><b>Country : </b></td><td>" + currentLocation.getCountry()  +"<sub>("+ currentLocation.getCountryCode().getIsoAlpha2()+"/" +currentLocation.getCountryCode().getIsoAlpha3() +"/"+currentLocation.getCountryCode().getUNCode() +")</sub></td></tr>");
        }
        sbPersonal.append("<tr><td><b>Preferred Location : </b></td><td></td></tr>");
        List<PreferredLocation> preferredLocations = resumeParserData.getPreferredLocation();
        for(PreferredLocation preferredLocation : preferredLocations)
        {
            sbPersonal.append("<tr><td><b>City : </b></td><td>" + preferredLocation.getCity() + "</td></tr>");
            sbPersonal.append("<tr><td><b>State : </b></td><td>" + preferredLocation.getState() +"<sub>"+preferredLocation.getStateIsoCode() + "</sub></td></tr>");
            sbPersonal.append("<tr><td><b>Country : </b></td><td>" + preferredLocation.getCountry() +"<sub>("+ preferredLocation.getCountryCode().getIsoAlpha2()+"/" +preferredLocation.getCountryCode().getIsoAlpha3() +"/"+preferredLocation.getCountryCode().getUNCode() +")</sub></td></tr>");
           
        }

       
      
        CandidateImage cImg= resumeParserData.getCandidateImage();
        if (cImg != null)
        {
            if (!cImg.getCandidateImageFormat().trim().isEmpty())
            {
                sbPersonal.append("<tr><td><b>CandidateImage. : </b></td><td><img style='display:block;border:1px;border-radius:3px;border:1px solid #fff; width:100px;height:100px;' id='imgCandidate' alt='Candidate Image' src='data:image/" + cImg.getCandidateImageFormat() + ";base64," + cImg.getCandidateImageData() + "' /></td></tr>");
            }
        }

        List<WebSite> websites = resumeParserData.getWebSite();
        if (!websites.isEmpty())
        {
            

        	for(WebSite website : websites)
            {
                sbPersonal.append("<tr><td><b>WebSite: Type : " + website.getType() + ": </b></td><td><a href='" +  website.getUrl() + "' target='_blank'>" +  website.getUrl() + "</a></td></tr>");
            }
        }
        sbPersonal.append("</table>");
       
        sbHtml.append("<h2>Personal Information</h2><hr/>");
        sbHtml.append(sbPersonal.toString());
        
        StringBuilder sbQualification = new StringBuilder();
        sbQualification.append("<table width='100%'> ");
        List<SegregatedQualification> segQualif = resumeParserData.getSegregatedQualification();
        if (!segQualif.isEmpty())
        {
        	int i=0;
            for (SegregatedQualification segregatedQualification:segQualif)
            {
                sbQualification.append("<tr><td colspan='2' align='center'><b>Qualification:-" + (i + 1) + "</b></td></tr>");

                if (segregatedQualification.getInstitution()!=null)
                {
                    if (segregatedQualification.getInstitution().getName()!=null)
                    {
                        sbQualification.append("<tr><td><b>InstitutionName:-</b></td><td>" + segregatedQualification.getInstitution().getName() + "<sub>" + segregatedQualification.getInstitution().getType() + "</sub></td></tr>");
                        sbQualification.append("<tr><td><b>InstitutionLocation:-</b></td><td>" + segregatedQualification.getInstitution().getLocation().getCity() + "<sub>City</sub>, " + segregatedQualification.getInstitution().getLocation().getState()+"("+ segregatedQualification.getInstitution().getLocation().getStateIsoCode()+")<sub>State</sub>, " + segregatedQualification.getInstitution().getLocation().getCountry() + "<sub>Country</sub>"+ "<sub>(" + segregatedQualification.getInstitution().getLocation().getCountryCode().getIsoAlpha2()+"/" + segregatedQualification.getInstitution().getLocation().getCountryCode().getIsoAlpha3() +"/"+ segregatedQualification.getInstitution().getLocation().getCountryCode().getUNCode() + ")</sub></td></tr>");
                    }
                }
                if (segregatedQualification.getSubInstitution() != null)
                {
                    if (segregatedQualification.getSubInstitution().getName()!=null)
                    {
                        sbQualification.append("<tr><td><b>SubInstitutionName:-</b></td><td>" + segregatedQualification.getSubInstitution().getName() + "<sub>" + segregatedQualification.getSubInstitution().getType() + "</sub></td></tr>");
                        sbQualification.append("<tr><td><b>SubInstitutionLocation:-</b></td><td>" + segregatedQualification.getSubInstitution().getLocation().getCity() + "<sub>City</sub>, "+ segregatedQualification.getSubInstitution().getLocation().getState()+"("+ segregatedQualification.getSubInstitution().getLocation().getStateIsoCode()+")<sub>State</sub>, "  + segregatedQualification.getSubInstitution().getLocation().getCountry()+ "<sub>Country</sub>"+ "<sub>(" + segregatedQualification.getSubInstitution().getLocation().getCountryCode().getIsoAlpha2()+"/" + segregatedQualification.getSubInstitution().getLocation().getCountryCode().getIsoAlpha3() +"/"+ segregatedQualification.getSubInstitution().getLocation().getCountryCode().getUNCode() + ")</sub></td></tr>");
                    }
                }
                sb.setLength(0);
               for (String spl : segregatedQualification.getDegree().getSpecialization())
                {
                    sb.append(spl + ",");
                }
                sbQualification.append("<tr><td><b>Degree:-</b></td><td>" + segregatedQualification.getDegree().getDegreeName() + "(" + segregatedQualification.getDegree().getNormalizeDegree() + ")" + "</td></tr>");
                sbQualification.append("<tr><td><b>Specialization:-</b></td><td>" + sb.toString() + "</td></tr>");
                sbQualification.append("<tr><td><b>FormattedDegreePeriod:-</b></td><td>" +segregatedQualification.getFormattedDegreePeriod() + "</td></tr>");
                sbQualification.append("<tr><td><b>StartDate:-</b></td><td>" +segregatedQualification.getStartDate() + "</td></tr>");
                sbQualification.append("<tr><td><b>EndDate:-</b></td><td>" + segregatedQualification.getEndDate() + "</td></tr>");
                if (segregatedQualification.getAggregate() != null)
                {
                    sbQualification.append("<tr><td><b>Aggregate:-</b></td><td><sub>" + segregatedQualification.getAggregate().getMeasureType() + "</sub>" + segregatedQualification.getAggregate().getValue() + "</td></tr>");
                }
                sbQualification.append("<tr><td colspan='2'><hr/></td></tr>");
                i++;
            }

            sbQualification.append("<tr><td colspan=3><hr/></td></tr>");
            sbQualification.append("<tr><td><b>Qualification Text Block</b></td><td colspan='2'><textarea>" + resumeParserData.getQualification() + "</textarea></td></tr>");
                                
        }
        sbQualification.append("</table>");
        sbHtml.append("<h2>Edcation Information</h2><hr/>");
        sbHtml.append(sbQualification.toString());
        
        StringBuilder sbExperience = new StringBuilder();
        sbExperience.append("<table width='100%' style=\"empty-cells: show\">");

        List<SegregatedExperience> segExperiences = resumeParserData.getSegregatedExperience();
        if (segExperiences != null)
         {
        	int i=0;
        	int j=0;
             for (SegregatedExperience segExp:segExperiences)
             {
            	 j=0;
            	 
            	//segExp.getJobProfile().getRelatedSkills().stream().forEach( p ->  System.out.println(p.getSkill()+":"+ p.getProficiencyLevel()));
            	 
                 sbExperience.append("<tr><td colspan='2' align='center'><b>Experice:-" + (i + 1) + "</b></td></tr>");
                 sbExperience.append("<tr><td><b>Employer:-</b></td><td>" + segExp.getEmployer().getEmployerName() + "</td></tr>");
                 sbExperience.append("<tr><td><b>JobProfile:-</b></td><td>" + segExp.getJobProfile().getTitle() + "</td></tr>");
                 
                 
                 
                 sbExperience.append("<tr><td><b>JobLocation:-</b></td><td>" + segExp.getLocation().getCity() + "," + segExp.getLocation().getState() +"("+ segExp.getLocation().getStateIsoCode()+")"+ ", " + segExp.getLocation().getCountry() + "<sub>(" + segExp.getLocation().getCountryCode().getIsoAlpha2()+"/" + segExp.getLocation().getCountryCode().getIsoAlpha3() +"/"+ segExp.getLocation().getCountryCode().getUNCode() + ")</sub></td></tr>");
                 
                 
                 
                 sbExperience.append("<tr><td><b>JobPeriod:-</b></td><td>" + segExp.getJobPeriod() + "</td></tr>");
                 sbExperience.append("<tr><td><b>FormattedJobPeriod:-</b></td><td>" + segExp.getFormattedJobPeriod() + "</td></tr>");
                 sbExperience.append("<tr><td><b>StartDate:-</b></td><td>" + segExp.getStartDate() + "</td></tr>");
                 sbExperience.append("<tr><td><b>EndDate:-</b></td><td>" + segExp.getEndDate() + "</td></tr>");
                 sbExperience.append("<tr><td><b>JobDescription:-</b></td><td><textarea>" +segExp.getJobDescription() + "</textarea></td></tr>");
                 StringBuilder sbProject = new StringBuilder();
                 sbProject.append("<table>");
                 sbProject.append("<tr><td>Sr.No.</td><td><b>Project Name</b></td><td><b>Used Skills</b></td><td><b>Team Size</b></td>");
                 
                 List<Projects> projects =segExp.getProjects();
                 for (Projects project:projects)
                 {
                     sbProject.append("<tr><td>" + (j + 1) + "</td><td>" + project.getProjectName() + "</td><td>" + project.getUsedSkills() + "</td><td>" + project.getTeamSize() + "</td>");
                 	j++;
                 }
                 sbProject.append("</table>");
                 sbExperience.append("<tr><td colspan='2'><div style='width:90%;' id='divProject" + (i + 1) + "'>" + sbProject + "</div></td></tr>");
                 sbExperience.append("<tr><td colspan='2'><hr/></td></tr>");
                 i++;
             }
             sbExperience.append("<tr><td><b>Experience Text Block</b></td><td colspan='2'><textarea>" + resumeParserData.getExperience() + "</textarea></td></tr>");
         }
        sbExperience.append("</table>");
        sbHtml.append("<h2>Experience Information</h2><hr/>");
        sbHtml.append(sbExperience.toString());
        List<SegregatedSkill> skillKeywords = resumeParserData.getSegregatedSkill();
        StringBuilder sbSkills = new StringBuilder();
        sbSkills.append("<table width='100%' >");
         if (skillKeywords.size()>0)
         {

             sbSkills.append("<tr><td><b>Skill</b></td><td><b>Exp.InMonth</b></td><td><b>LastUsed</b></td><td><b>FormattedName</b></td><td><b>Alias</b></td></tr>");
             for(SegregatedSkill skill : skillKeywords)
             {
                 sbSkills.append("<tr><td>" + skill.getSkill() + "<sub>" + skill.getEvidence() + "</sub></td><td>" + skill.getExperienceInMonths() + "</td><td>" + skill.getLastUsed() + "</td><td>" + skill.getFormattedName() + "</td><td>" + skill.getAlias() + "</td></tr>");
             }
             sbSkills.append("<tr><td><b>Skill Text Block</b></td><td colspan='4'><textarea>" + resumeParserData.getSkillBlock() + "</textarea></td></tr>");
         }
          sbSkills.append("</table>");
        
          sbHtml.append("<h2>Skill Information</h2><hr/>");
          sbHtml.append(sbSkills.toString());
          StringBuilder sbOther = new StringBuilder();
          sbOther.append("<table width=100% >");
          sbOther.append("<tr><td><b>Resume File Name : </b></td><td>" + resumeParserData.getResumeFileName() + "</td></tr>");
          sbOther.append("<tr><td><b>Resume Language : </b></td><td>" + resumeParserData.getResumeLanguage().getLanguage() + "(" + resumeParserData.getResumeLanguage().getLanguageCode() + ")</td></tr>");
          sbOther.append("<tr><td><b>Parsing Date : </b></td><td>" + resumeParserData.getParsingDate() + "</td></tr>");
          sbOther.append("<tr><td><b>Category : </b></td><td>" + resumeParserData.getCategory() + "</td></tr>");
          sbOther.append("<tr><td><b>SubCategory : </b></td><td>" + resumeParserData.getSubCategory() + "</td></tr>");

          List<LanguageKnown> languageKnowns = resumeParserData.getLanguageKnown();
          sb.setLength(0);
          for(LanguageKnown languageKnown : languageKnowns)
          {
              sb.append(languageKnown.getLanguage() + "(" + languageKnown.getLanguageCode() + "),");
          }
          sbOther.append("<tr><td><b>Language Known : </b></td><td>" + sb.toString() + "</td></tr>");
          
          WorkedPeriod workPeriod=resumeParserData.getWorkedPeriod();
          if (workPeriod != null)
          {
              sbOther.append("<tr><td><b>Worked Period in Month: </b></td><td>" + workPeriod.getTotalExperienceInMonths() + "</td></tr>");
              sbOther.append("<tr><td><b>Worked Period in Year: </b></td><td>" + workPeriod.getTotalExperienceInYear() + "</td></tr>");
              sbOther.append("<tr><td><b>Worked Period Range: </b></td><td>" + workPeriod.getTotalExperienceRange() + "</td></tr>");
          }
          sbOther.append("<tr><td><b>Gap Period  : </b></td><td>" + resumeParserData.getGapPeriod() + "</td></tr>");
          sbOther.append("<tr><td><b>Average Stay  : </b></td><td>" + resumeParserData.getAverageStay() + "</td></tr>");
          sbOther.append("<tr><td><b>Longest Stay  : </b></td><td>" + resumeParserData.getLongestStay() + "</td></tr>");
          sbOther.append("<tr><td><b>Summary  : </b></td><td><textarea>" + resumeParserData.getSummary() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>ExecutiveSummary  : </b></td><td><textarea>" + resumeParserData.getExecutiveSummary() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>ManagementSummary  : </b></td><td><textarea>" + resumeParserData.getManagementSummary() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Availability  : </b></td><td>" + resumeParserData.getAvailability() + "</td></tr>");
          sbOther.append("<tr><td><b>Cover Letter	 : </b></td><td><textarea>" + resumeParserData.getCoverletter() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Certification : </b></td><td><textarea>" + resumeParserData.getCertification() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>SegregatedCertification : </b></td><td></td></tr>");

          for (SegregatedCertification segCertification : resumeParserData.getSegregatedCertification())
          {
              sbOther.append("<tr><td><b>Certification Title : </b></td><td>" + segCertification.getCertificationTitle() + "</td></tr>");
              sbOther.append("<tr><td><b>Certification Code : </b></td><td>" + segCertification.getCertificationCode() + "</td></tr>");
              sbOther.append("<tr><td><b>Certification Url : </b></td><td>" + segCertification.getCertificationUrl() + "</td></tr>");
              sbOther.append("<tr><td><b>Authority : </b></td><td>" + segCertification.getAuthority() + "</td></tr>");
              sbOther.append("<tr><td><b>StartDate : </b></td><td>" + segCertification.getStartDate() + "</td></tr>");
              sbOther.append("<tr><td><b>EndDate : </b></td><td>" + segCertification.getEndDate() + "</td></tr>");
              sbOther.append("<tr><td><b>IsExpiry : </b></td><td>" + segCertification.getIsExpiry() + "</td></tr>");
              sbOther.append("<tr><td colspan='2'><hr/></td></tr>");
          }

          sbOther.append("<tr><td><b>Publication : </b></td><td><textarea>" + resumeParserData.getPublication() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>SegregatedPublication : </b></td><td></td></tr>");
          
          for (SegregatedPublication segPublication : resumeParserData.getSegregatedPublication())
          {
              sbOther.append("<tr><td><b>Publication Title : </b></td><td>" + segPublication.getPublicationTitle() + "</td></tr>");
              sbOther.append("<tr><td><b>Publication Number : </b></td><td>" + segPublication.getPublicationNumber() + "</td></tr>");
              sbOther.append("<tr><td><b>PublicationUrl  : </b></td><td>" + segPublication.getPublicationUrl() + "</td></tr>");
              sbOther.append("<tr><td><b>Publisher : </b></td><td>" + segPublication.getPublisher() + "</td></tr>");
              sbOther.append("<tr><td><b>Authors : </b></td><td>" + segPublication.getAuthors() + "</td></tr>");
              sbOther.append("<tr><td><b>Description : </b></td><td><textarea>" + segPublication.getDescription() + "</textarea></td></tr>");
              sbOther.append("<tr><td colspan='2'><hr/></td></tr>");
          }
          sbOther.append("<tr><td><b>Hobbies : </b></td><td><textarea>" + resumeParserData.getHobbies() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Objectives : </b></td><td><textarea>" + resumeParserData.getObjectives() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Achievements : </b></td><td><textarea>" + resumeParserData.getAchievements() + "</textarea></td></tr>");

          for(SegregatedAchievement segAchievement : resumeParserData.getSegregatedAchievement())
          {
              sbOther.append("<tr><td><b>Award Title : </b></td><td>" + segAchievement.getAwardTitle() + "</td></tr>");
              sbOther.append("<tr><td><b>Associated With : </b></td><td>" + segAchievement.getAssociatedWith() + "</td></tr>");
              sbOther.append("<tr><td><b>Issuer : </b></td><td>" + segAchievement.getIssuer() + "</td></tr>");
              sbOther.append("<tr><td><b>Issuing Date : </b></td><td>" + segAchievement.getIssuingDate() + "</td></tr>");

              sbOther.append("<tr><td><b>Description : </b></td><td><textarea>" + segAchievement.getDescription() + "</textarea></td></tr>");
              sbOther.append("<tr><td colspan='2'><hr/></td></tr>");
          }

          sbOther.append("<tr><td><b>References   : </b></td><td><textarea>" + resumeParserData.getReferences() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Detail Resume   : </b></td><td><textarea>" + resumeParserData.getDetailResume() + "</textarea></td></tr>");
          sbOther.append("<tr><td><b>Html Resume   : </b></td><td><textarea>" + resumeParserData.getHtmlResume() + "</textarea></td></tr>");
          sbOther.append("</table>");
          sbHtml.append("<h2>Other Information</h2><hr/>");
          sbHtml.append(sbOther.toString());
          
          return sbHtml.toString(); 
          
	}

}
